<template>
  <div id="teacher_class_index_wrapper" class="bt-container">
    <h2 class="page-title">{{ $t('REALTIME.TITLE') }}</h2>
    <br>
    <b>학생간 화면 공유 기능: </b>
    <el-switch
      v-model="shareSnapshotBetweenStudents"
      active-color="#2497D8"
      inactive-color="#ff4949"
      @change="changeShareStatus">
    </el-switch>
    <p v-if="shareSnapshotBetweenStudents === true">현재 학생간 화면 공유 기능이 <b style="color: blue;">활성화</b>된 상태입니다. 학생들은 서로의 화면을 볼 수 <b style="color: blue;">있습니다</b>.</p>
    <p v-if="shareSnapshotBetweenStudents === false">현재 학생간 화면 공유 기능이 <b style="color: red;">비활성화</b>된 상태입니다. 학생들은 서로의 화면을 볼 수 <b style="color: red;">없습니다</b>.</p>
    <br />
    <br />
    <b>관찰할 카메라 번호: </b>
    <el-select
      v-model="cameraNumber">
      <el-option
        v-for="option in cameraNumberOptions"
        :key="option.value"
        :label="option.label"
        :value="option.value">
      </el-option>
    </el-select>
   <div v-show="connection">
      <el-row :gutter="20">
        <el-col :span="10">
          <h3>{{ $t('REALTIME.STUDENT') }}</h3>
          <video controls width="100%" ref="studentVideo"/>
          <el-button type="primary" @click="disconnect">{{ $t('REALTIME.OVER') }}</el-button>
      </el-col>
        <el-col v-show="showMyVideo" :span="10">
          <h3>{{ $t('REALTIME.LECTURER') }}</h3>
          <video controls muted width="100%" ref="teacherVideo"/>
        </el-col>
      </el-row>
      <el-button v-if='!showMyVideo' type="primary" @click="showMyVideo = true">{{ $t('REALTIME.VIEW_MY_PAGE') }}</el-button>
      <el-button v-if='showMyVideo' type="danger" @click="showMyVideo = false">{{ $t('REALTIME.FOLD_MY_PAGE') }}</el-button>
    </div>
    <div style="height: 50px;" />

    <template v-for="student in listOfStudents">
      <span :key="student.user_id">
        <span v-if="student.cam[cameraNumber-1] === undefined" style="display:inline-block; vertical-align: top; width: 200px; text-align:center; position: relative">
          <i class="fa fa-circle" style="position: absolute; top: 7px; left: 15px; color:red"></i>
          <img :src="'https://image.flaticon.com/icons/svg/167/167750.svg'" width="180" height="180" />
          <br/>
            {{ student.name }}
          <br/>
        </span>
        <span v-else style="display:inline-block; vertical-align: top; width: 200px; text-align:center; position: relative">
          <i class="fa fa-circle" v-show="!student.cam[cameraNumber-1].is_connecting" style="position: absolute; top: 7px; left: 15px; color:red"></i>
          <i class="fa fa-circle" v-show="student.cam[cameraNumber-1].is_connecting" style="position: absolute; top: 7px; left: 15px; color:green"></i>
          <img :src="student.cam[cameraNumber-1].src" width="180" height="180" />
          <br/>
            {{ student.name }}
          <br/>
          <!-- <br/>
            <el-button type="small" @click="connect(student.user_id)">{{ $t('REALTIME.TRY') }}</el-button>
          <br/> -->
        </span>
      </span>
    </template>
  </div>
</template>

<script>
import lectureService from '../../services/lectureService';
import utils from '../../utils';

export default {
  name: 'RealtimeWebcamLecture',
  data() {
    return {
      nameFaceData: [], // 테이블에 담길 내용
      connection: false, // 현재 연결 중 여부
      nowId: '', // 현재 연결중인 학생 ID
      count: 0,

      cameraNumber: 1,
      cameraNumberOptions: [{
        value: 1,
        label: 1,
      }, {
        value: 2,
        label: 2,
      }, {
        value: 3,
        label: 3,
      }, {
        value: 4,
        label: 4,
      }, {
        value: 5,
        label: 5,
      }],

      // webRTC
      pc: undefined,
      configuration: {
        iceServers: [
          {
            urls: 'stun:stun.l.google.com:19302',
          },
        ],
      },
      teacherVideo: undefined,
      studentVideo: undefined,
      listOfStudents: [],
      showMyVideo: false,
      showSubScreen: false,
      shareSnapshotBetweenStudents: false,
    };
  },
  async created() {
    const vm = this;
    // 1:1 통신용 매개변수 초기화
    const params = {
      lecture_id: vm.lectureId,
      user_id: utils.getUserIdFromJwt(),
    };
    if(utils.getAuthTypeFromJwt2() !== 1) {
      vm.$router.push({path: `/`}); // 권한 없는 경우
      vm.$notify({
        title: vm.$t('NOTIFY.FAIL'),
        message: "The account does not have enough privileges.",
        type: 'error',
        duration: 3000,
      });          
    };

    vm.sockets.subscribe('CONNECTED', () => {
      vm.$socket.emit('JOIN_LECTURE', JSON.stringify(params));
    });
    const listOfStudents = await lectureService.getWholeStudents({
      id: vm.$route.params.lectureId,
    });

    listOfStudents.data.forEach((element) => {
      element.cam = [];
      vm.listOfStudents.push(element);
    });


    

    vm.teacherVideo = vm.$refs.teacherVideo;
    vm.studentVideo = vm.$refs.studentVideo;

    // 1:1 통화
    vm.sockets.subscribe('VIDEO_CALL', async (evt) => {
      const signal = JSON.parse(evt);
      if (signal.from !== vm.nowId) { // 통신하려는 상대의 신호가 아니면 무시
        return;
      }
      if (signal.sdp) {
        vm.pc.setRemoteDescription(new RTCSessionDescription(signal.sdp));
        if (signal.sdp.type === 'offer') {
          const desc = await vm.pc.createAnswer();
          vm.pc.setLocalDescription(desc);
          vm.$socket.emit('VIDEO_CALL', JSON.stringify({
            lecture_id: vm.lectureId,
            from: utils.getUserIdFromJwt(),
            to: vm.nowId,
            sdp: desc,
          }));
        }
      } else {
        vm.pc.addIceCandidate(new RTCIceCandidate(signal.candidate));
      }
    });

    // 주기적 학생 스냅샷 획득
    vm.sockets.subscribe('SEND_SNAPSHOT', (evt) => {
      const signal = JSON.parse(evt);

      // 탐색 후 알맞은 자리에 매핑
      vm.listOfStudents.forEach((element, index) => {
        if (element.user_id === signal.from) {
          let registered = false;
          for(let i = 0 ; i < vm.listOfStudents[index].cam.length ; i += 1) { // 이미 등록한 카메라의 신호인지 확인
            if (vm.listOfStudents[index].cam[i].socket_id === signal.from_socket_id) {
              vm.$set(vm.listOfStudents[index].cam[i], 'src', signal.snapshot);
              vm.$set(vm.listOfStudents[index].cam[i], 'last_shooting_time', new Date());
              registered = true;
            }
          }
          if (registered === false) { // 아직 등록된 카메라가 아니라면,
            let arrLength = vm.listOfStudents[index].cam.length;
            vm.listOfStudents[index].cam.push({});
            vm.$set(vm.listOfStudents[index].cam[arrLength], 'src', signal.snapshot);
            vm.$set(vm.listOfStudents[index].cam[arrLength], 'last_shooting_time', new Date());            
            vm.$set(vm.listOfStudents[index].cam[arrLength], 'socket_id', signal.from_socket_id);
          }
        }
      });
    });

    vm.checkConnection(); // 학생 스냅샷 연결 여부 확인

    // 학생이 1:1요청을 보낸 경우
    vm.sockets.subscribe('REQUEST_CALL', (msg) => {
      const jsonMSG = JSON.parse(msg);
      
      vm.$notify({
        title: vm.$t('NOTIFY.TITLE'),
        message: vm.$t('NOTIFY.REQUEST_ONE_TO_ONE') + `${jsonMSG.email_from}`,
        type: 'success',
      });
    });
  },
  mounted() {
    const vm = this;
    vm.teacherVideo = vm.$refs.teacherVideo;
    vm.studentVideo = vm.$refs.studentVideo;
    vm.changeShareStatus(false);
  },
  methods: {
    async connect(id) {
      const vm = this;
      if (id) vm.nowId = id;
      let hasVideo = false;

      // 내가 통화 가능한 상태인지 파악한다.
      try {
        const devices = await navigator.mediaDevices.enumerateDevices();
        devices.forEach((device) => {
          if (device.kind === 'videoinput') {
            hasVideo = true;
          }
        });
        await navigator.mediaDevices.getUserMedia({
          audio: true,
          video: hasVideo,
        });
      } catch (err) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('REALTIME.FAILED1'),
          type: 'warning',
        });
        return;
      }

      // if (vm.connection) {
      //   vm.disconnect();
      //   vm.$notify({
      //     title: vm.$t('NOTIFY.TITLE'),
      //     message: '진행중인 통화를 종료하고, 새 통화를 시작합니다.',
      //     type: 'warning',
      //   });
      // }

      vm.pc = new RTCPeerConnection(vm.configuration);

      // send any ice candidates to the other peer
      vm.pc.onicecandidate = function (evt) {
        vm.$socket.emit('VIDEO_CALL', JSON.stringify({
          lecture_id: vm.lectureId,
          from: utils.getUserIdFromJwt(),
          to: vm.nowId,
          candidate: evt.candidate,
        }));
      };

      // once remote stream arrives, show it in the remote video element
      vm.pc.onaddstream = function (evt) {
        vm.studentVideo.srcObject = evt.stream;
        vm.studentVideo.play();
      };

      vm.pc.oniceconnectionstatechange = function () {
        if (vm.pc.iceConnectionState === 'disconnected') {
          console.log('Disconnected');
          vm.disconnect();
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('REALTIME.END'),
            type: 'warning',
          });
        }
      };

      try {
        const stream = await navigator.mediaDevices.getUserMedia({
          audio: true,
          video: hasVideo,
        });
        vm.teacherVideo.srcObject = stream;
        vm.teacherVideo.play();
        vm.pc.addStream(stream);
        const desc = await vm.pc.createOffer();
        vm.pc.setLocalDescription(desc);
        vm.$socket.emit('VIDEO_CALL', JSON.stringify({
          lecture_id: vm.lectureId,
          from: utils.getUserIdFromJwt(),
          to: vm.nowId,
          sdp: desc,
        }));
      } catch (err) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('REALTIME.FAILED2'),
          type: 'warning',
        });
      }
      vm.connection = true;
    },
    // 연결 종료
    disconnect() {
      const vm = this;
      vm.connection = false;
      vm.pc.close();
      vm.pc = null;
      vm.teacherVideo.srcObject = null;
      vm.studentVideo.srcObject = null;
    },
    checkConnection() {
      const vm = this;
      setInterval(() => {
        const currentTime = new Date();
        vm.listOfStudents.forEach((element, index) => {
          for (let i = 0 ; i < element.cam.length ; i += 1) {
            if( i === 1 ) {
            }
            if (element.cam[i].last_shooting_time === undefined) {
              vm.$set(vm.listOfStudents[index].cam[i], 'is_connecting', false);
            } else if (currentTime - element.cam[i].last_shooting_time > 10000) {
              vm.$set(vm.listOfStudents[index].cam[i], 'is_connecting', false);
              vm.listOfStudents[index].cam.splice(i,1); // 10초 이상 신호 없으면 제거
            } else {
              vm.$set(vm.listOfStudents[index].cam[i], 'is_connecting', true);
            }
          }
        });
      }, 10000);
    },
    async changeShareStatus(arg) {
      const vm = this;

      // https 서버에 신호를 보냄
      await lectureService.postSnapshotStatus({
        lectureId: vm.lectureId,
        status: arg,
      })

      // 소켓 서버에 신호를 보냄
      vm.$socket.emit('SNAPSHOT_STATUS_CHANGED', JSON.stringify({
        lecture_id: vm.lectureId,
        from: utils.getUserIdFromJwt(),
        to: 'everyone',
        status: arg,
      }));
    }
  },
  computed: {
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
  },
};
</script>